/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2012-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  上記著作権者は，以下の(1)〜(4)の条件を満たす場合に限り，本ソフトウェ
 *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
 *  変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
 *  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
 *      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
 *      スコード中に含まれていること．
 *  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
 *      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
 *      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
 *      の無保証規定を掲載すること．
 *  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
 *      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
 *      と．
 *    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
 *        作権表示，この利用条件および下記の無保証規定を掲載すること．
 *    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
 *        報告すること．
 *  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
 *      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
 *      また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
 *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
 *      免責すること．
 *
 *  本ソフトウェアは，AUTOSAR（AUTomotive Open System ARchitecture）仕
 *  様に基づいている．上記の許諾は，AUTOSARの知的財産権を許諾するもので
 *  はない．AUTOSARは，AUTOSAR仕様に基づいたソフトウェアを商用目的で利
 *  用する者に対して，AUTOSARパートナーになることを求めている．
 *
 *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
 *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
 *  に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
 *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
 *  の責任を負わない．
 *
 *  $Id: prc_tool.h 182 2015-06-24 07:14:37Z t_ishikawa $
 */

/*
 *		ツール依存モジュール（V850用）
 */
#ifndef TOPPERS_PRC_TOOL_H
#define TOPPERS_PRC_TOOL_H

#ifndef TOPPERS_MACRO_ONLY

/*
 * CFGの pass 1 で STACK_MAGIC_NUMBER を取得するために定義
 */
#ifdef TOPPERS_CFG1_OUT
#define CFG_USE_STACKMONITORING
#endif /* TOPPERS_CFG1_OUT */

/*
 *  関数のアライン単位
 *  CXでは2バイト境界にも配置する．
 */
#define CHECK_FUNC_ALIGN	2

/*
 *  メモリ再読込が必要なことをコンパイラに伝えるためのダミー関数（prs_support.asm）
 *  CX にはGNUのAsm("":::memory);相当がないため空の関数を呼び出す．
 */
extern void v850_memory_changed(void);

/*
 *  メモリの再読み込みが必要なことをコンパイラに伝える
 */
#define V850_MEMORY_CHANGED	v850_memory_changed();

#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_PRC_TOOL_H */
