; 
;  TOPPERS ATK2
;      Toyohashi Open Platform for Embedded Real-Time Systems
;      Automotive Kernel Version 2
;
;  Copyright (C) 2012-2015 by Center for Embedded Computing Systems
;              Graduate School of Information Science, Nagoya Univ., JAPAN
;
;  上記著作権者は，以下の(1)〜(4)の条件を満たす場合に限り，本ソフトウェ
;  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
;  変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
;  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
;      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
;      スコード中に含まれていること．
;  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
;      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
;      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
;      の無保証規定を掲載すること．
;  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
;      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
;      と．
;    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
;        作権表示，この利用条件および下記の無保証規定を掲載すること．
;    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
;        報告すること．
;  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
;      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
;      また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
;      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
;      免責すること．
;
;  本ソフトウェアは，AUTOSAR（AUTomotive Open System ARchitecture）仕
;  様に基づいている．上記の許諾は，AUTOSARの知的財産権を許諾するもので
;  はない．AUTOSARは，AUTOSAR仕様に基づいたソフトウェアを商用目的で利
;  用する者に対して，AUTOSARパートナーになることを求めている．
;
;  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
;  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
;  に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
;  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
;  の責任を負わない．
;
;  $Id: v850asm.inc 182 2015-06-24 07:14:37Z t_ishikawa $
;

;
;  V850アセンブラ用定義ファイル
;

__ccrh__      .set    1
__v850e3v5__  .set    1
USE_ASMCONFIG_INC .set 1
PSW_SV        .set    2
NO_SVC        .set    1
NO_HOOK_RET   .set    2
SHUTDOWN_HOOK .set    1
TMAX_SVCID    .set    63
FE_MP_MASK    .set    0x9e
FE_MP_BIT     .set    0x90
TFN_EXIT_TASK .set    61	;/*(TMAX_SVCID - TARGET_SVC_NUM) */
PEOB_STACKMONITORING_INTERRUPT  .set 0x80
PEOB_STACKMONITORING_DISPATCH   .set 0x40
PEOB_STACKMONITORING_TERMTASK   .set 0x20
E_OS_PROTECTION_MEMORY .set 14
E_OS_STACKINSUFFICIENT .set 28
E_OK          .set    0
TRUE          .set    1
SYSCALL_SIZE  .set    2

;/*****************************************************************************/
;/* システムレジスタ番号の定義												  */
;/*****************************************************************************/
	eipc	.set	0
	eipsw	.set	1
	fepc	.set	2
	fepsw	.set	3
	ecr		.set	4
	psw		.set	5
	sccfg	.set	11
	scbp	.set	12
	eiic	.set	13
	feic	.set	14
	eiwr	.set	28
	fewr	.set	29

;/*
; * ラベルロード Lea (Load Effective Address)
; */
Lea .macro name, destination
;	ld.w $name, destination
	mov32	#name, destination
.endm

;/*
; *  全割込み禁止マクロ
; */
LOCK_ALL_INT .macro 
    di
.endm

;/*
; *  全割込み禁止解除マクロ
; */
UNLOCK_ALL_INT .macro 
    ei
.endm
