/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2012-2016 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012-2014 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2012-2013 by Spansion LLC, USA
 *  Copyright (C) 2012-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2012-2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2012-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2012-2014 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2012-2014 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2012-2014 by Witz Corporation, JAPAN
 *
 *  上記著作権者は，以下の(1)〜(4)の条件を満たす場合に限り，本ソフトウェ
 *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
 *  変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
 *  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
 *      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
 *      スコード中に含まれていること．
 *  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
 *      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
 *      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
 *      の無保証規定を掲載すること．
 *  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
 *      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
 *      と．
 *    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
 *        作権表示，この利用条件および下記の無保証規定を掲載すること．
 *    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
 *        報告すること．
 *  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
 *      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
 *      また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
 *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
 *      免責すること．
 *
 *  本ソフトウェアは，AUTOSAR（AUTomotive Open System ARchitecture）仕
 *  様に基づいている．上記の許諾は，AUTOSARの知的財産権を許諾するもので
 *  はない．AUTOSARは，AUTOSAR仕様に基づいたソフトウェアを商用目的で利
 *  用する者に対して，AUTOSARパートナーになることを求めている．
 *
 *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
 *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
 *  に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
 *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
 *  の責任を負わない．
 *
 *  $Id: target_kernel.h 35 2014-07-17 14:00:37Z ertl-honda $
 */

/*
 *		Os.hのターゲット依存部（RH850F1H_PB用）
 *
 *  このインクルードファイルは，Os.hでインクルードされる
 *  他のファイルから直接インクルードすることはない
 */

#ifndef TOPPERS_TARGET_KERNEL_H
#define TOPPERS_TARGET_KERNEL_H

#include "rh850f1h_pb.h"

/* チェック用タスクスタックサイズの最小値の定義 */
#define TARGET_MIN_STKSZ	196

/* チェック用非タスクコンテキスト用のスタック最小値の定義 */
#define MINIMUM_OSTKSZ	256

/* 各スタックサイズのデフォルト値の定義*/
#define DEFAULT_TASKSTKSZ	(1024U) /* 1K bytes */
#define DEFAULT_TASKSYSTEMSTKSZ			(1024U) /* 1K bytes */
#define DEFAULT_ISRSTKSZ	(1024U) /* 1K bytes */
#define DEFAULT_ISRSYSTEMSTKSZ			(1024U) /* 1K bytes */
#define DEFAULT_HOOKSTKSZ	(1024U) /* 1K bytes */
#define DEFAULT_TRUSTEDFUNCTIONSTKSZ	(128U)  /* 128 bytes */
#define DEFAULT_OSSTKSZ		(8192U) /* 8K bytes */

/* コンテキストの保存復帰にPUSHSP/POPSPを使用 */
#define TOPPERS_USE_PUSHSP

/*
 *  プロセッサで共通な定義
 */
#include "v850_gcc/prc_kernel.h"

#define TARGET_SVC_NUM	(PRC_SVC_NUM)

#endif /* TOPPERS_TARGET_KERNEL_H */
